#include "block.h"
#include "draw.h"
#include "button.h"
#include <reg52.h>

char base[MAX_X][MAX_Y] = {0}; //x*y	//0Ϊ 1Ϊ 2Ϊ
extern unsigned char score;
extern enum OPR opr;
enum GS blockGameStatus = __idle;

void blockInit()
{
  blockGameStatus = start;
}

void blockDestroy()
{
  memset(base, 0, sizeof(base));
  blockGameStatus = over;
}

void genPiece()
{

  char i, j;
  //Ҫһ
  int random = TH0 % 10;


  if(blockGameStatus == over)
    return;


  //δɵķ
  for(i = 0; i < MAX_X; i++)
    for(j = 0; j < MAX_Y; j++)
      if(base[i][j] == 2)
        return;

  //
  if(random == 0)
    {
      base[4][9] = 2;
    }

  //
  if(random == 1 || random == 2)
    {
      base[4][9] = 2;							//
      base[4][10] = 2;						//
    }
  else if(random == 3)
    {
      base[3][9] = 2;						////
      base[4][9] = 2;
    }

  //
  else if(random == 4 || random == 5)
    {

      base[4][11] = 2;
      base[4][10] = 2;
      base[4][9] = 2;
    }
  else if(random == 6)
    {
      base[3][9] = 2;
      base[4][9] = 2;
      base[5][9] = 2;
    }
  else if(random == 7)
    {
      base[3][10] = 2;
      base[3][9] = 2;
      base[4][9] = 2;
    }
  else if (random == 8)
    {
      base[4][9] = 2;
      base[3][9] = 2;
      base[4][9] = 2;
    }

//ĸ
  else if(random == 9)
    {
      base[3][10] = 2;
      base[4][10] = 2;
      base[3][9] = 2;
      base[4][9] = 2;
    }
}

//ǷĻ
unsigned char isIegal(char i, char j)
{
  if(i >= 0 && i < MAX_X && j >= 0 && j < MAX_Y && base[i][j] != 1)
    return 1;
  return 0;
}

//
void drawBlock()
{
  char i, j;

  for(i = 0; i < 8; i++)
    for(j = 0; j < 8; j++)
      if(base[i][j] != 0)
        placeIMG_BLOCK(i, j);
      else
        placeVOID_BLOCK(i, j);
}

//ϲ
void dropPiece()
{
  char i, j, flag = 0;

  //Ƿ񴥵
  for(i = 0; i < MAX_X; i++)
    {
      for(j = 0; j < MAX_Y; j++)
        {
          if(flag == 1)
            break;
          if(base[i][j] == 2)
            {
              //,
              if(flag == 0 && (base[i][j - 1] == 1 || j == 0))
                {
                  flag = 1;
                  break;
                }

            }
        }
      if(flag == 1)
        break;
    }
  //תǶ
  for(i = 0; i < MAX_X; i++)
    {
      for(j = 0; j < MAX_Y; j++)
        {
          if(base[i][j] == 2)
            {
              //ޱ
              if(flag == 0 && isIegal(i, j - 1))
                {
                  base[i][j - 1] = 2;
                  base[i][j] = 0;
                }
              //бת
              else if(flag == 1)
                base[i][j] = 1;
            }
        }
    }

}

//ƽ
void moveLeftPiece()
{

  char i, j;
  if(blockGameStatus == over)
    return;
  for(i = 0; i < MAX_X; i++)
    for(j = 0; j < MAX_Y; j++)
      if(base[i][j] == 2 && !isIegal(i - 1, j))
        {
          return;
        }
  for(i = 0; i < MAX_X; i++)
    for(j = 0; j < MAX_Y; j++)
      if(base[i][j] == 2)
        {
          base[i - 1][j] = 2;
          base[i][j] = 0;
        }
}
void moveRightPiece()

{
  char i, j;
  if(blockGameStatus == over)
    return;
  for(i = MAX_X - 1; i >= 0; i--)
    for(j = MAX_Y - 1; j >= 0; j--)
      if(base[i][j] == 2 && !isIegal(i + 1, j))
        {
          return;
        }
  for(i = MAX_X - 1; i >= 0; i--)
    for(j = MAX_Y - 1; j >= 0; j--)
      if(base[i][j] == 2 )
        {
          base[i + 1][j] = 2;
          base[i][j] = 0;
        }
}

//жǷϷ/
void judgeBlock()
{
  char i, j, k, h, count;
  if(blockGameStatus == over)
    return;
  //ɨ
  for(j = 0; j < MAX_Y; j++)
    {
      count = 0;
      for(i = 0; i < MAX_X; i++)
        {
          //
          if(base[i][j] == 1)
            {
              count++;
            }
        }
      //
      if(count == 8)
        {
          score++;
          blockGameStatus = good;
          for(k = 0; k < MAX_X; k++)
            for(h = j ; h < MAX_Y - 1; h++)
              base[k][h] = base[k][h + 1];
        }

    }
}

void blockGameOver()
{
  char j,i;
	if(blockGameStatus == over)
    return;
  for(j = 0; j < MAX_X; j++)
    {
      //Ϸ
      if(base[j][7] == 1)
        {
          blockGameStatus = over;
          break;
        }
    }
  //
  if(blockGameStatus == over)
    {
      for(j = 0; j < MAX_Y; j++)
        for(i = 0; i < MAX_X; i++)
          base[i][j] = 1;
    }
}