#include "menu.h"
#include "display.h"
#include "delay.h"
#include "draw.h"
#include <stdio.h>
#include <stdlib.h>
#include "block.h"

//ڵԵԤ
//#define DEBUG_MODE

#ifdef DEBUG_MODE
#define M_DEBUG M_BLOCK
#endif

Menu M_MAINMENU;//˵
Menu M_BLOCK; 	//˹
Menu M_BALL;		//

Menu M_ABOUT;

Menu* NOW; //ǰ˵ָ
Menu* LAST = NULL; //һ״̬Ĳ˵

enum OPR opr = idle;
static unsigned char local[10] = {0};
unsigned char score = 0;
extern enum GS blockGameStatus;


//˵
void m_mainmenu(struct _menu* this)
{
  if(LAST != &M_MAINMENU)
    {
      LAST = &M_MAINMENU;
      drawMAINMENU(local[0]);
    }

  if(opr == right)
    {
      local[0]++;
      if(local[0] > 3)
        local[0] = 3;

      opr = idle;
      drawMAINMENU(local[0]);
    }
  if(opr == left)
    {
      if(local[0] != 0)
        local[0]--;

      opr = idle;
      drawMAINMENU(local[0]);
    }
  if(opr == confirm)
    {

      switch(local[0])
        {
        case 0:
          return;
        case 1:
          NOW = &M_BLOCK;				//תһ˵
          break;
        case 2:
          NOW = &M_BALL;				//תһ˵
          break;
        case 3:
          NOW = &M_ABOUT;			//תһ˵
          break;
        }

      local[0] = 0;
      clear();
      opr = idle;
    }
}


//Ϸ
void m_block(struct _menu* this)
{
  if(LAST != &M_BLOCK)
    {
      LAST = &M_BLOCK;
      drawVerticalDottedLine(64);
      drawBLOCKSCORE();
      blockInit();
    }
  //
  if(opr == confirm)
    {
      opr = idle;
      blockDestroy();
			NOW=&M_MAINMENU;
			clear();
      return;
    }
  if(opr == left)
    {
      opr = idle;
      moveLeftPiece();
			drawBlock();
			return;
    }
  if(opr == right)
    {
      opr = idle;
      moveRightPiece();
			drawBlock();
			return;
    }
  switch(blockGameStatus)
    {
    case good:
      drawGOOD(70, 2);
			blockGameStatus=start;
      break;
    case over:
      drawGAME(70, 2);
      drawOVER(70, 4);
      break;
    default:
      drawVOID8(70, 2, 40);
      drawVOID8(70, 4, 32);
    }
  drawSUPNUM(110, 0, score);		//Ʒ
	blockGameOver();							//ǷϷ
  genPiece();  									//Ҫ¿
  dropPiece();									//Ҫ
  judgeBlock();									//Ҫһ
  drawBlock();									//ƽ
  delayms(400);

}

//ҳ
void m_about(struct _menu* this)
{


  if(LAST != &M_ABOUT)
    {
      LAST = &M_ABOUT;

      drawNAME(); 		 		//
      delayms(2000);
      drawNUMBER(); 			//ѧ
    }

  if(opr == confirm)
    {
      opr = idle;
      NOW = &M_MAINMENU;				//תһ˵
      clear();
    }
}

void menuInit()
{

  M_MAINMENU.f = m_mainmenu;
  M_BLOCK.f = m_block;
	M_ABOUT.f = m_about;

#ifdef DEBUG_MODE
  NOW = &M_DEBUG;
#else
  NOW = &M_MAINMENU;
#endif
}
